Index: src/wp-admin/admin-header.php
===================================================================
--- src/wp-admin/admin-header.php	(revision 28206)
+++ src/wp-admin/admin-header.php	(working copy)
@@ -157,7 +157,7 @@
 
 ?>
 </head>
-<?php
+<body class="wp-admin wp-core-ui no-js <?php
 /**
  * Filter the admin <body> CSS classes.
  *
@@ -169,8 +169,8 @@
  *
  * @param string $classes Space-separated string of CSS classes.
  */
-?>
-<body class="wp-admin wp-core-ui no-js <?php echo apply_filters( 'admin_body_class', '' ) . " $admin_body_class"; ?>">
+echo apply_filters( 'admin_body_class', '' ) . " $admin_body_class";
+?>">
 <script type="text/javascript">
 	document.body.className = document.body.className.replace('no-js','js');
 </script>
Index: src/wp-admin/edit-form-advanced.php
===================================================================
--- src/wp-admin/edit-form-advanced.php	(revision 28206)
+++ src/wp-admin/edit-form-advanced.php	(working copy)
@@ -382,7 +382,8 @@
 	<span class="hide-if-no-sessionstorage"><?php _e( 'We&#8217;re backing up this post in your browser, just in case.' ); ?></span>
 	</p>
 </div>
-<?php
+
+<form name="post" action="post.php" method="post" id="post"<?php
 /**
  * Fires inside the post editor <form> tag.
  *
@@ -390,8 +391,8 @@
  *
  * @param WP_Post $post Post object.
  */
-?>
-<form name="post" action="post.php" method="post" id="post"<?php do_action( 'post_edit_form_tag', $post ); ?>>
+do_action( 'post_edit_form_tag', $post );
+?>>
 <?php wp_nonce_field($nonce_action); ?>
 <input type="hidden" id="user-id" name="user_ID" value="<?php echo (int) $user_ID ?>" />
 <input type="hidden" id="hiddenaction" name="action" value="<?php echo esc_attr( $form_action ) ?>" />
Index: src/wp-admin/edit-tag-form.php
===================================================================
--- src/wp-admin/edit-tag-form.php	(revision 28206)
+++ src/wp-admin/edit-tag-form.php	(working copy)
@@ -64,7 +64,8 @@
 <div class="wrap">
 <h2><?php echo $tax->labels->edit_item; ?></h2>
 <div id="ajax-response"></div>
-<?php
+
+<form name="edittag" id="edittag" method="post" action="edit-tags.php" class="validate" <?php
 /**
  * Fires inside the Edit Term form tag.
  *
@@ -73,8 +74,8 @@
  *
  * @since 3.7.0
  */
-?>
-<form name="edittag" id="edittag" method="post" action="edit-tags.php" class="validate"<?php do_action( "{$taxonomy}_term_edit_form_tag" ); ?>>
+do_action( "{$taxonomy}_term_edit_form_tag" );
+?>>
 <input type="hidden" name="action" value="editedtag" />
 <input type="hidden" name="tag_ID" value="<?php echo esc_attr($tag->term_id) ?>" />
 <input type="hidden" name="taxonomy" value="<?php echo esc_attr($taxonomy) ?>" />
Index: src/wp-admin/edit-tags.php
===================================================================
--- src/wp-admin/edit-tags.php	(revision 28206)
+++ src/wp-admin/edit-tags.php	(working copy)
@@ -431,7 +431,8 @@
 
 <div class="form-wrap">
 <h3><?php echo $tax->labels->add_new_item; ?></h3>
-<?php
+
+<form id="addtag" method="post" action="edit-tags.php" class="validate"<?php
 /**
  * Fires at the beginning of the Add Tag form.
  *
@@ -439,8 +440,8 @@
  *
  * @since 3.7.0
  */
-?>
-<form id="addtag" method="post" action="edit-tags.php" class="validate"<?php do_action( "{$taxonomy}_term_new_form_tag" ); ?>>
+do_action( "{$taxonomy}_term_new_form_tag" );
+?>>
 <input type="hidden" name="action" value="add-tag" />
 <input type="hidden" name="screen" value="<?php echo esc_attr($current_screen->id); ?>" />
 <input type="hidden" name="taxonomy" value="<?php echo esc_attr($taxonomy); ?>" />
Index: src/wp-admin/includes/meta-boxes.php
===================================================================
--- src/wp-admin/includes/meta-boxes.php	(revision 28206)
+++ src/wp-admin/includes/meta-boxes.php	(working copy)
@@ -626,9 +626,11 @@
  * @param object $post
  */
 function post_slug_meta_box($post) {
-/** This filter is documented in wp-admin/edit-tag-form.php */
 ?>
-<label class="screen-reader-text" for="post_name"><?php _e('Slug') ?></label><input name="post_name" type="text" size="13" id="post_name" value="<?php echo esc_attr( apply_filters( 'editable_slug', $post->post_name ) ); ?>" />
+<label class="screen-reader-text" for="post_name"><?php _e('Slug') ?></label><input name="post_name" type="text" size="13" id="post_name" value="<?php
+	/** This filter is documented in wp-admin/edit-tag-form.php */
+	echo esc_attr( apply_filters( 'editable_slug', $post->post_name ) );
+?>" />
 <?php
 }
 
Index: src/wp-admin/includes/template.php
===================================================================
--- src/wp-admin/includes/template.php	(revision 28206)
+++ src/wp-admin/includes/template.php	(working copy)
@@ -1800,16 +1800,17 @@
 
 	if ( $is_IE )
 		@header('X-UA-Compatible: IE=edge');
-
+?>
+<!DOCTYPE html>
+<!--[if IE 8]>
+<html xmlns="http://www.w3.org/1999/xhtml" class="ie8 <?php echo $admin_html_class; ?>" <?php
 /**
  * Fires inside the HTML tag in the admin header.
  *
  * @since 2.2.0
  */
-?>
-<!DOCTYPE html>
-<!--[if IE 8]>
-<html xmlns="http://www.w3.org/1999/xhtml" class="ie8 <?php echo $admin_html_class; ?>" <?php do_action( 'admin_xml_ns' ); ?> <?php language_attributes(); ?>>
+do_action( 'admin_xml_ns' ); ?> <?php language_attributes();
+?>>
 <![endif]-->
 <!--[if !(IE 8) ]><!-->
 <?php /** This action is documented in wp-admin/includes/template.php */ ?>
Index: src/wp-admin/plugin-install.php
===================================================================
--- src/wp-admin/plugin-install.php	(revision 28206)
+++ src/wp-admin/plugin-install.php	(working copy)
@@ -89,8 +89,8 @@
  *
  * @param int $paged The current page number of the plugins list table.
  */
+do_action( "install_plugins_$tab", $paged );
 ?>
-<?php do_action( "install_plugins_$tab", $paged ); ?>
 </div>
 <?php
 /**
Index: src/wp-admin/user-edit.php
===================================================================
--- src/wp-admin/user-edit.php	(revision 28206)
+++ src/wp-admin/user-edit.php	(working copy)
@@ -221,14 +221,15 @@
 	<?php }
 } ?>
 </h2>
-<?php
+
+<form id="your-profile" action="<?php echo esc_url( self_admin_url( IS_PROFILE_PAGE ? 'profile.php' : 'user-edit.php' ) ); ?>" method="post"<?php
 /**
  * Fires inside the your-profile form tag on the user editing screen.
  *
  * @since 3.0.0
  */
-?>
-<form id="your-profile" action="<?php echo esc_url( self_admin_url( IS_PROFILE_PAGE ? 'profile.php' : 'user-edit.php' ) ); ?>" method="post"<?php do_action( 'user_edit_form_tag' ); ?>>
+do_action( 'user_edit_form_tag' );
+?>>
 <?php wp_nonce_field('update-user_' . $user_id) ?>
 <?php if ( $wp_http_referer ) : ?>
 	<input type="hidden" name="wp_http_referer" value="<?php echo esc_url($wp_http_referer); ?>" />
@@ -250,7 +251,7 @@
 <?php if ( count($_wp_admin_css_colors) > 1 && has_action('admin_color_scheme_picker') ) : ?>
 <tr>
 <th scope="row"><?php _e('Admin Color Scheme')?></th>
-<?php
+<td><?php
 /**
  * Fires in the 'Admin Color Scheme' section of the user editing screen.
  *
@@ -259,8 +260,8 @@
  *
  * @since 3.0.0
  */
-?>
-<td><?php do_action( 'admin_color_scheme_picker', $user_id ); ?></td>
+do_action( 'admin_color_scheme_picker', $user_id );
+?></td>
 </tr>
 <?php
 endif; // $_wp_admin_css_colors
Index: src/wp-admin/user-new.php
===================================================================
--- src/wp-admin/user-new.php	(revision 28206)
+++ src/wp-admin/user-new.php	(working copy)
@@ -279,14 +279,14 @@
 		$label = __('E-mail or Username');
 	}
 ?>
-<?php
+<form action="" method="post" name="adduser" id="adduser" class="validate"<?php
 /**
  * Fires inside the adduser form tag.
  *
  * @since 3.0.0
  */
-?>
-<form action="" method="post" name="adduser" id="adduser" class="validate"<?php do_action( 'user_new_form_tag' );?>>
+do_action( 'user_new_form_tag' );
+?>>
 <input name="action" type="hidden" value="adduser" />
 <?php wp_nonce_field( 'add-user', '_wpnonce_add-user' ) ?>
 