Index: src/wp-admin/css/customize-controls.css
===================================================================
--- src/wp-admin/css/customize-controls.css	(revision 38868)
+++ src/wp-admin/css/customize-controls.css	(working copy)
@@ -21,7 +21,7 @@
 }
 
 #customize-controls .description {
-	color: #555;
+	color: #555d66;
 }
 
 #customize-header-actions .button-primary {
@@ -82,7 +82,7 @@
 
 #customize-controls .customize-info .accordion-section-title {
 	background: #fff;
-	color: #555;
+	color: #555d66;
 	border-left: none;
 	border-right: none;
 	border-bottom: none;
@@ -92,7 +92,7 @@
 #customize-controls .customize-info.open .accordion-section-title:after,
 #customize-controls .customize-info .accordion-section-title:hover:after,
 #customize-controls .customize-info .accordion-section-title:focus:after {
-	color: #333;
+	color: #32373c;
 }
 
 #customize-controls .customize-info .accordion-section-title:after {
@@ -153,7 +153,7 @@
 #customize-controls .customize-info .customize-panel-description,
 #customize-controls .customize-info .customize-section-description,
 #customize-controls .no-widget-areas-rendered-notice {
-	color: #555;
+	color: #555d66;
 	display: none;
 	background: #fff;
 	padding: 12px 15px;
@@ -187,9 +187,9 @@
 }
 
 #customize-theme-controls .accordion-section-title {
-	color: #555;
+	color: #555d66;
 	background-color: #fff;
-	border-bottom: 1px solid #eee;
+	border-bottom: 1px solid #ddd;
 	border-left: 4px solid #fff;
 }
 
@@ -199,7 +199,7 @@
 }
 
 #customize-theme-controls .accordion-section-content {
-	color: #555;
+	color: #555d66;
 	background: transparent;
 }
 
@@ -207,8 +207,12 @@
 #customize-controls .control-section .accordion-section-title:hover,
 #customize-controls .control-section.open .accordion-section-title,
 #customize-controls .control-section .accordion-section-title:focus {
-	color: #191e23;
+	color: #0073aa;
 	background: #f5f5f5;
+	border-left-color: #f5f5f5;
+}
+
+#customize-controls .control-section .accordion-section-title:focus {
 	border-left: 4px solid #0073aa;
 }
 
@@ -227,7 +231,7 @@
 #customize-theme-controls .control-section .accordion-section-title:hover:after,
 #customize-theme-controls .control-section.open .accordion-section-title:after,
 #customize-theme-controls .control-section .accordion-section-title:focus:after {
-	color: #23282d;
+	color: #0073aa;
 }
 
 #customize-theme-controls .control-section.open {
@@ -392,7 +396,7 @@
 	padding: 10px 10px 12px 14px;
 	margin: 0;
 	line-height: 21px;
-	color: #555;
+	color: #555d66;
 }
 
 .accordion-sub-container.control-panel-content {
@@ -467,7 +471,7 @@
 
 #customize-controls .panel-meta.customize-info .accordion-section-title:hover {
 	background: #fff;
-	color: #555;
+	color: #555d66;
 	border-left: none;
 }
 
@@ -475,19 +479,25 @@
 .customize-controls-close:hover,
 .customize-controls-preview-toggle:focus,
 .customize-controls-preview-toggle:hover {
-	background: #ddd;
-	border-color: #ccc;
-	color: #000;
+	background: #fff;
+	color: #0073aa;
 	outline: none;
 	-webkit-box-shadow: none;
 	box-shadow: none;
 }
 
+
+.customize-controls-close:focus,
+.customize-controls-preview-toggle:focus {
+	border-top: 4px solid #0073aa;
+	height: 41px;
+}
+
 .customize-panel-back:hover,
 .customize-panel-back:focus,
 .customize-section-back:hover,
 .customize-section-back:focus {
-	color: #23282d;
+	color: #0073aa;
 	background: #f5f5f5;
 	outline: none;
 	-webkit-box-shadow: none;
@@ -494,6 +504,11 @@
 	box-shadow: none;
 }
 
+.customize-panel-back:focus,
+.customize-section-back:focus {
+	border-left: 4px solid #0073aa;
+}
+
 .customize-controls-close:before {
 	font: normal 22px/45px dashicons;
 	content: "\f335";
@@ -502,6 +517,10 @@
 	left: 13px;
 }
 
+.customize-controls-close:focus:before {
+	top: -3px;
+}
+
 .customize-panel-back:before,
 .customize-section-back:before {
 	font: normal 20px/72px dashicons;
@@ -510,6 +529,11 @@
 	left: 13px;
 }
 
+.customize-panel-back:focus:before,
+.customize-section-back:focus:before {
+	left: 10px;
+}
+
 .wp-full-overlay-sidebar .wp-full-overlay-header {
 	background-color: #eee;
 	-webkit-transition: padding ease-in-out .18s;
@@ -801,7 +825,7 @@
 }
 
 .customize-control-color .dropdown .dropdown-content {
-	background-color: #555;
+	background-color: #555d66;
 	border: 1px solid rgba(0, 0, 0, 0.15);
 }
 
@@ -884,7 +908,7 @@
 	display: none;
 	position: absolute;
 	width: 100%;
-	color: #555;
+	color: #555d66;
 	white-space: nowrap;
 	text-overflow: ellipsis;
 	overflow: hidden;
@@ -933,7 +957,7 @@
 .customize-control-header .uploaded .header-view .close {
 	font-size: 20px;
 	color: #fff;
-	background: #555;
+	background: #555d66;
 	background: rgba(0, 0, 0, 0.5);
 	position: absolute;
 	top: 10px;
@@ -1079,7 +1103,7 @@
 #customize-theme-controls .control-panel-themes > .accordion-section-title {
 	cursor: default;
 	background: #fff;
-	color: #555;
+	color: #555d66;
 	border-top: 1px solid #ddd;
 	border-bottom: 1px solid #ddd;
 	border-left: none;
@@ -1346,11 +1370,15 @@
 
 .control-panel-themes .customize-themes-section-title:focus,
 .control-panel-themes .customize-themes-section-title:hover {
-	border-left-color: #0073aa;
 	color: #0073aa;
 	background: #f5f5f5;
+    border-left-color: #f5f5f5;
 }
 
+.control-panel-themes .customize-themes-section-title:focus {
+	border-left-color: #0073aa;
+}
+
 .control-panel-themes .theme-section .customize-themes-section-title.selected:after {
 	content: "\f147";
 	font: 16px/1 dashicons;
@@ -2155,7 +2183,7 @@
 		background: #eee;
 		border: 0;
 		border-right: 1px solid #ddd;
-		color: #444;
+		color: #555d66;
 		cursor: pointer;
 		-webkit-transition: color .1s ease-in-out, background .1s ease-in-out;
 		transition: color .1s ease-in-out, background .1s ease-in-out;
@@ -2236,7 +2264,7 @@
 		padding: 9px 10px 12px 14px;
 		margin: 0;
 		line-height: 24px;
-		color: #555;
+		color: #555d66;
 		display: block;
 		overflow: hidden;
 		white-space: nowrap;
Index: src/wp-admin/css/customize-widgets.css
===================================================================
--- src/wp-admin/css/customize-widgets.css	(revision 38868)
+++ src/wp-admin/css/customize-widgets.css	(working copy)
@@ -231,6 +231,10 @@
 #available-widgets .widget-tpl.selected {
 	background: #f5f5f5;
 	border-bottom-color: #ccc;
+	color: #0073aa;
+}
+
+#available-widgets .widget-tpl.selected { /* Used for focus */
 	border-left: 4px solid #0073aa;
 }
 
Index: src/wp-admin/css/themes.css
===================================================================
--- src/wp-admin/css/themes.css	(revision 38868)
+++ src/wp-admin/css/themes.css	(working copy)
@@ -1538,14 +1538,16 @@
 }
 
 .wp-full-overlay-footer .devices button:focus {
-	background-color: #fff;
 	border-bottom-color: #0073aa;
 }
 
-.wp-full-overlay-footer .devices button.active:before,
+.wp-full-overlay-footer .devices button.active:before {
+	color: #191e23;
+}
+
 .wp-full-overlay-footer .devices button:hover:before,
 .wp-full-overlay-footer .devices button:focus:before {
-	color: #191e23;
+	color: #0073aa;
 }
 
 .wp-full-overlay-footer .devices .preview-desktop:before {
Index: src/wp-admin/js/customize-controls.js
===================================================================
--- src/wp-admin/js/customize-controls.js	(revision 38868)
+++ src/wp-admin/js/customize-controls.js	(working copy)
@@ -980,6 +980,7 @@
 				content = section.contentContainer,
 				overlay = section.headContainer.closest( '.wp-full-overlay' ),
 				backBtn = content.find( '.customize-section-back' ),
+				focusTarget = content.find( ':focusable' ).first() || backBtn,
 				sectionTitle = section.headContainer.find( '.accordion-section-title' ).first(),
 				expand;
 
@@ -993,7 +994,7 @@
 							sectionTitle.attr( 'tabindex', '-1' );
 							backBtn.attr( 'tabindex', '0' );
 
-							backBtn.focus();
+							focusTarget.focus();
 							content.css( 'top', '' );
 							container.scrollTop( 0 );
 
@@ -1969,7 +1970,8 @@
 				overlay = accordionSection.closest( '.wp-full-overlay' ),
 				container = accordionSection.closest( '.wp-full-overlay-sidebar-content' ),
 				topPanel = panel.headContainer.find( '.accordion-section-title' ),
-				backBtn = accordionSection.find( '.customize-panel-back' );
+				backBtn = accordionSection.find( '.customize-panel-back' ),
+				focusTarget = accordionSection.find( ':focusable' ).first() || backBtn;
 
 			if ( expanded && ! accordionSection.hasClass( 'current-panel' ) ) {
 				// Collapse any sibling sections/panels
@@ -1988,7 +1990,7 @@
 					topPanel.attr( 'tabindex', '-1' );
 					backBtn.attr( 'tabindex', '0' );
 
-					backBtn.focus();
+					focusTarget.focus();
 					accordionSection.css( 'top', '' );
 					container.scrollTop( 0 );
 